{
  ͻ                   
   OpenSource Library                    
  ͼ                   
   Author : Vitaly Checkryzhev (Virtualik) 
   E-Mail : virty1k@mail.ru                
   WWW    : http://www.str.ru/~virty       
   WWW    : http://virtualsoft.narod.ru    
   WWW    : http://chat.str.ru             
                                           
  VIRtUal Soft         All rights reserved 
 
  
}
{    ⨪- }

uses graph, crt;

type
 TDirection = (dLeft, dRight, dUp, dDown);
 TField = object
  Procedure Init(ClNum, CColor: Word);
  Procedure Draw(Clr: Byte);
  Procedure DrawCell(pX, pY: Word);
  Procedure MoveCursor(Direction: TDirection);
  Procedure PutObject;
  Procedure CheckCells;
 private
  aX, aY,       {Coords of leftmost upper table corner}
  wd,hd,        {Width and height of table}
  Cells,        {Cell count}
  clHd, clWd,   {Cell width and height}
  CurColor,     {Cursor color}
  CurObj,
  cX, cY: Word; {Cursor position}
  Matrix: Array [1..10, 1..10] of Byte;
 end;

procedure Beep;
begin
 Sound(60);
 Delay(5000);
 NoSound;
end;

Procedure TField.Init(ClNum, CColor: Word);
var
 I: Integer;
begin
 CurColor := CColor;
 Cells := ClNum;
 FillChar(Matrix, Cells*2, 0);
 Wd := GetMaxX div 2;
 Hd := Wd;
 aX := Wd div 2;
 aY := GetMaxY div 4;
 clHd := Hd div Cells;
 clWd := Wd div Cells;

 CurObj := 1;

 cX := 1;
 cY := 1;

 For I := 0 to Cells do
  begin
   Line(aX, aY + I*ClHd, aX + Cells*ClWd, aY + I*ClHd);
   Line(aX + I*ClWd, aY, aX + I*ClWd, aY + Cells*ClHd);
  end;
 Draw(CurColor);
end;

Procedure TField.MoveCursor(Direction: TDirection);
begin
 Draw(GetBkColor);
 case Direction of
  dLeft : if cX>1 then cX := cX - 1;
  dRight: if cX<Cells then cX := cX + 1;
  dUp   : if cY>1 then cY := cY - 1;
  dDown : if cY<Cells then cY := cY + 1;
 end;
 Draw(CurColor);
end;

Procedure TField.Draw(Clr: Byte);
begin
 { ᮢ  }
 SetColor(Clr);
 SetLineStyle(0,0,3);
 Rectangle(
           aX + (cX-1)*clWd + 2,
           aY + (cY-1)*clHd + 2,
           aX + (cX-1)*clWd - 2 + clWd,
           aY + (cY-1)*clHd - 2 + clHd);
end;

Procedure TField.DrawCell(pX, pY: Word);
begin
 case Matrix[pX, pY] of
  1: begin
      SetColor(9);
      Circle(
            aX + (pX-1)*clWd + clWd div 2,
            aY + (pY-1)*clWd + clHd div 2,
            (ClWd div 2) - 7);
      end;
  2: begin
      SetColor(10);
      Line(aX + (pX-1)*clWd + 7,
           aY + (pY-1)*clHd + 7,
           aX + (pX-1)*clWd - 7 + ClWd,
           aY + (pY-1)*clHd - 7 + ClWd);
      Line(aX + (pX-1)*clWd + 7,
           aY + (pY-1)*clHd - 7 + ClWd,
           aX + (pX-1)*clWd - 7 + ClWd,
           aY + (pY-1)*clHd + 7);
     end;
 end;
end;

Procedure TField.CheckCells;
begin
 { ஢ઠ ᫮  먣 ப }
end;

Procedure TField.PutObject;
begin
 {  ꥪ (⨪/)  祩 }
 if Matrix[cX, cY]=0 then
  begin
   CurObj := 1 - CurObj;
   Matrix[cX, cY] := CurObj + 1;
   DrawCell(cX, cY);
   CheckCells;
  end else Beep;
end;

var
 I       : Integer;
 K       : Char;
 Field   : TField;

begin
 InitGraph(I, I, '');
 Field.Init(3, 4);
 Repeat
  if KeyPressed then
   begin
    K := Readkey;
    if K = #0 then K := Readkey;
    case K of
     #72: Field.MoveCursor(dUp);
     #80: Field.MoveCursor(dDown);
     #75: Field.MoveCursor(dLeft);
     #77: Field.MoveCursor(dRight);
     #13, #32: Field.PutObject;
    end;
   end;
 Until K=#27;
 CloseGraph;
end.